"use strict";
// This file is part of phosphor-float-area, copyright (C) 2017 BusFaster Ltd.
// Released under the MIT license, see LICENSE.
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var messaging_1 = require("@phosphor/messaging");
/** Message sent by a dialog requesting a parent layout to move or resize it. */
var DialogUpdateMessage = /** @class */ (function (_super) {
    __extends(DialogUpdateMessage, _super);
    function DialogUpdateMessage(
        /** Dialog to move or resize. */
        widget, x, y, width, height, 
        /** Mouse event causing the message to be sent, if applicable. */
        event) {
        var _this = _super.call(this, 'dialog-update') || this;
        _this.widget = widget;
        _this.x = x;
        _this.y = y;
        _this.width = width;
        _this.height = height;
        _this.event = event;
        return _this;
    }
    /** Conflate subsequent update messages to leave only the latest one. */
    DialogUpdateMessage.prototype.conflate = function (other) {
        // Only conflate messages related to the same widget.
        if (this.widget != other.widget)
            return (false);
        // Copy information from the newer message (which will be discarded).
        this.x = other.x;
        this.y = other.y;
        this.width = other.width;
        this.height = other.height;
        // Accept the conflation.
        return (true);
    };
    return DialogUpdateMessage;
}(messaging_1.ConflatableMessage));
exports.DialogUpdateMessage = DialogUpdateMessage;
/** Message sent by a dialog requesting a parent layout to raise it
  * over other dialogs in the z-order. */
var DialogRaiseMessage = /** @class */ (function (_super) {
    __extends(DialogRaiseMessage, _super);
    function DialogRaiseMessage(
        /** Dialog to raise. */
        widget, 
        /** Mouse event causing the message to be sent, if applicable. */
        event) {
        var _this = _super.call(this, 'dialog-raise') || this;
        _this.widget = widget;
        _this.event = event;
        return _this;
    }
    return DialogRaiseMessage;
}(messaging_1.Message));
exports.DialogRaiseMessage = DialogRaiseMessage;
//# sourceMappingURL=DialogMessage.js.map